'use strict';
var callExpressionA = require('nodes');
var nodes = callExpressionA.nodes, syntax = callExpressionA.syntax;
var callExpression = require('../util/id');
var createUniqueDeclaration = callExpression.createUniqueDeclaration;
exports.default = function arrowify(program) {
  var arrowFunctions = program.search('#ArrowFunctionExpression');
  arrowFunctions.forEach(function (node) {
    if (node.expression) {
      node.expression = false;
      node.body = new nodes.BlockStatement({ body: [new nodes.ReturnStatement({ argument: node.body })] });
    }
    var arrowScope = node.scope('[type!=ArrowFunctionExpression]');
    node.search('=> #ThisExpression, => #Identifier:reference[name=arguments]').forEach(function (expression) {
      var id;
      if (expression.type === syntax.ThisExpression) {
        id = createUniqueDeclaration(arrowScope, 'self', 'this');
      } else {
        id = createUniqueDeclaration(arrowScope, 'parameters', 'arguments');
      }
      expression.parentNode.replaceChild(expression, id);
    });
  });
  arrowFunctions.forEach(function (node) {
    var shallow = new nodes.FunctionExpression(node);
    node.parentNode.replaceChild(node, shallow);
  });
};